export default {
  props: {
    // we're calling this customProp so that we can save custom name for templates
    customProp: {
      type: Object,
      default () {
        return {}
      }
    }
  },
  computed: {
    // custom options for particular field
    custom () {
      let custom = {}
      if (this.root) {
        // custom options for single element
        custom = Object.assign({}, this.defaults, this.customProp)
      } else {
        // custom options for multiple elements
        for (const [key, obj] of Object.entries(this.defaults || {})) {
          custom[key] = Object.assign({}, obj, this.customProp[key])
        }
      }
      return custom
    }
  }
}
