export default {
  props: {
    commit: String,
    dispatch: String,
    event: String
  },
  methods: {
    emit () {
      if (this.$store) {
        this.commitMutation()
        this.dispatchAction()
      }
      this.emitEvent(this.event)
      // i guess at some point i decided that groups don't use that
      if (this.isField) {
        this.emitEvent(this.settings.event)
      }
      this.$emit('input', this.fieldModel)
    },
    commitMutation () {
      if (this.commit) {
        this.$store.commit(this.commit, this.fieldModel)
      }
    },
    dispatchAction () {
      if (this.dispatch) {
        this.$store.dispatch(this.dispatch, {
          field: this.name,
          model: this.fieldModel
        })
      }
    },
    emitEvent (event) {
      if (event) {
        this.$emit('event', {
          name: event,
          field: this.name,
          model: this.fieldModel
        })
      }
    }
  }
}