import checkbox from './checkbox'
import custom from './custom'
import emit from './emit'
import model from './model'
import options from './options'
import password from './password'
import texts from './texts'
import validation from './validation'

export default {
  mixins: [
    checkbox,
    custom,
    emit,
    model,
    options,
    password,
    texts,
    validation
  ],
  props: {
    field: {
      type: Object,
      default () {
        return {}
      }
    },
    settings: Object,
    components: {
      type: Object,
      default () {
        return {}
      }
    },
    schema: Object,
    disabled: {
      required: false
    },
    wrapper: {
      type: String,
      default: 'div'
    },
    slots: Array,
    state: String,
    name: {
      type: String,
      required: true
    },
    type: String,
    i18n: Array
  },
  computed: {
    isField () {
      return this.type !== 'group'
    }
  },
  methods: {
    // support for function values for all keys
    // would be nice to have it for custom too
    f (val) {
      return typeof val === 'function' ? val() : val
    },
    getSlot (slot, key) {
      return key + (this.slots.indexOf(slot) + 1)
    },
    isActive (field) {
      return !field.hasOwnProperty('active') ? true : (typeof field.active === 'function' ? field.active() : field.active)
    },
    areEqual (left, right) {
      return JSON.stringify(left) === JSON.stringify(right)
    }
  }
}
